/* Generated by wayland-scanner 1.22.0 */

#ifndef UKUI_OUTPUT_V1_CLIENT_PROTOCOL_H
#define UKUI_OUTPUT_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_ukui_output_v1 The ukui_output_v1 protocol
 * @section page_ifaces_ukui_output_v1 Interfaces
 * - @subpage page_iface_ukui_output_management_v1 - ukui output management
 * - @subpage page_iface_ukui_output_v1 - output device
 * @section page_copyright_ukui_output_v1 Copyright
 * <pre>
 *
 * SPDX-FileCopyrightText: 2024 KylinSoft Co., Ltd.
 *
 * SPDX-License-Identifier: MulanPSL-2.0
 * </pre>
 */
struct ukui_output_management_v1;
struct ukui_output_v1;

#ifndef UKUI_OUTPUT_MANAGEMENT_V1_INTERFACE
#define UKUI_OUTPUT_MANAGEMENT_V1_INTERFACE
/**
 * @page page_iface_ukui_output_management_v1 ukui_output_management_v1
 * @section page_iface_ukui_output_management_v1_desc Description
 *
 * This interface is a manager that allows show some additional output info.
 * @section page_iface_ukui_output_management_v1_api API
 * See @ref iface_ukui_output_management_v1.
 */
/**
 * @defgroup iface_ukui_output_management_v1 The ukui_output_management_v1 interface
 *
 * This interface is a manager that allows show some additional output info.
 */
extern const struct wl_interface ukui_output_management_v1_interface;
#endif
#ifndef UKUI_OUTPUT_V1_INTERFACE
#define UKUI_OUTPUT_V1_INTERFACE
/**
 * @page page_iface_ukui_output_v1 ukui_output_v1
 * @section page_iface_ukui_output_v1_desc Description
 *
 * A output has some read-only properties: name, usable_area.
 * These cannot be changed by clients.
 * @section page_iface_ukui_output_v1_api API
 * See @ref iface_ukui_output_v1.
 */
/**
 * @defgroup iface_ukui_output_v1 The ukui_output_v1 interface
 *
 * A output has some read-only properties: name, usable_area.
 * These cannot be changed by clients.
 */
extern const struct wl_interface ukui_output_v1_interface;
#endif

/**
 * @ingroup iface_ukui_output_management_v1
 * @struct ukui_output_management_v1_listener
 */
struct ukui_output_management_v1_listener {
	/**
	 * introduce a new output
	 *
	 * This event introduces a new output. This happens whenever a
	 * new output appears (e.g. a monitor is plugged in) or after the
	 * ukui_output_management_v1 is bound.
	 */
	void (*output)(void *data,
		       struct ukui_output_management_v1 *ukui_output_management_v1,
		       struct ukui_output_v1 *output);
	/**
	 * sent all output information
	 *
	 * This event is sent after all information has been sent after
	 * binding to the output manager object and after any subsequent
	 * changes. This applies to child output as well.
	 */
	void (*done)(void *data,
		     struct ukui_output_management_v1 *ukui_output_management_v1);
};

/**
 * @ingroup iface_ukui_output_management_v1
 */
static inline int
ukui_output_management_v1_add_listener(struct ukui_output_management_v1 *ukui_output_management_v1,
				       const struct ukui_output_management_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) ukui_output_management_v1,
				     (void (**)(void)) listener, data);
}

#define UKUI_OUTPUT_MANAGEMENT_V1_DESTROY 0

/**
 * @ingroup iface_ukui_output_management_v1
 */
#define UKUI_OUTPUT_MANAGEMENT_V1_OUTPUT_SINCE_VERSION 1
/**
 * @ingroup iface_ukui_output_management_v1
 */
#define UKUI_OUTPUT_MANAGEMENT_V1_DONE_SINCE_VERSION 1

/**
 * @ingroup iface_ukui_output_management_v1
 */
#define UKUI_OUTPUT_MANAGEMENT_V1_DESTROY_SINCE_VERSION 1

/** @ingroup iface_ukui_output_management_v1 */
static inline void
ukui_output_management_v1_set_user_data(struct ukui_output_management_v1 *ukui_output_management_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) ukui_output_management_v1, user_data);
}

/** @ingroup iface_ukui_output_management_v1 */
static inline void *
ukui_output_management_v1_get_user_data(struct ukui_output_management_v1 *ukui_output_management_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) ukui_output_management_v1);
}

static inline uint32_t
ukui_output_management_v1_get_version(struct ukui_output_management_v1 *ukui_output_management_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) ukui_output_management_v1);
}

/**
 * @ingroup iface_ukui_output_management_v1
 */
static inline void
ukui_output_management_v1_destroy(struct ukui_output_management_v1 *ukui_output_management_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) ukui_output_management_v1,
			 UKUI_OUTPUT_MANAGEMENT_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) ukui_output_management_v1), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_ukui_output_v1
 * @struct ukui_output_v1_listener
 */
struct ukui_output_v1_listener {
	/**
	 * output name
	 *
	 * This event describes the name of output.
	 *
	 * The name event is sent after a ukui_output_v1 object is created.
	 * This event is only sent once per object, and the name does not
	 * change over the lifetime of the ukui_output_v1 object.
	 * @param name name of output
	 */
	void (*name)(void *data,
		     struct ukui_output_v1 *ukui_output_v1,
		     const char *name);
	/**
	 * output usable_area
	 *
	 * This event describes the usable_area of output.
	 * @param x x of the output usable_area
	 * @param y y of the output usable_area
	 * @param width width of the output usable_area
	 * @param height height of the output usable_area
	 */
	void (*usable_area)(void *data,
			    struct ukui_output_v1 *ukui_output_v1,
			    int32_t x,
			    int32_t y,
			    int32_t width,
			    int32_t height);
	/**
	 * the output has disappeared
	 *
	 * This event indicates that the ukui_output_v1 is no longer
	 * available. Clients should send a destroy request and release any
	 * resources associated with it.
	 */
	void (*finished)(void *data,
			 struct ukui_output_v1 *ukui_output_v1);
};

/**
 * @ingroup iface_ukui_output_v1
 */
static inline int
ukui_output_v1_add_listener(struct ukui_output_v1 *ukui_output_v1,
			    const struct ukui_output_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) ukui_output_v1,
				     (void (**)(void)) listener, data);
}

#define UKUI_OUTPUT_V1_DESTROY 0

/**
 * @ingroup iface_ukui_output_v1
 */
#define UKUI_OUTPUT_V1_NAME_SINCE_VERSION 1
/**
 * @ingroup iface_ukui_output_v1
 */
#define UKUI_OUTPUT_V1_USABLE_AREA_SINCE_VERSION 1
/**
 * @ingroup iface_ukui_output_v1
 */
#define UKUI_OUTPUT_V1_FINISHED_SINCE_VERSION 1

/**
 * @ingroup iface_ukui_output_v1
 */
#define UKUI_OUTPUT_V1_DESTROY_SINCE_VERSION 1

/** @ingroup iface_ukui_output_v1 */
static inline void
ukui_output_v1_set_user_data(struct ukui_output_v1 *ukui_output_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) ukui_output_v1, user_data);
}

/** @ingroup iface_ukui_output_v1 */
static inline void *
ukui_output_v1_get_user_data(struct ukui_output_v1 *ukui_output_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) ukui_output_v1);
}

static inline uint32_t
ukui_output_v1_get_version(struct ukui_output_v1 *ukui_output_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) ukui_output_v1);
}

/**
 * @ingroup iface_ukui_output_v1
 */
static inline void
ukui_output_v1_destroy(struct ukui_output_v1 *ukui_output_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) ukui_output_v1,
			 UKUI_OUTPUT_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) ukui_output_v1), WL_MARSHAL_FLAG_DESTROY);
}

#ifdef  __cplusplus
}
#endif

#endif
